/* DoctorMX Library for Win32 */
/* (c)2010 Yuji Kuwabara  kuwatec, Inc. */

#ifndef	_DDrMXLib_h_
#define	_DDrMXLib_h_


#ifdef __cplusplus
extern "C" {
#endif


typedef	void*	RDrMXEnum;	/* reference to enumerator */
typedef	void*	RDrMX;		/* reference to device */


/*--- device enumerator ---*/

/*
 returns NULL if failed to create enumerator, otherwise valid enumerator reference.
*/
extern	RDrMXEnum	WINAPI	DrMXEnum_New();

/*
  aE : enumerator reference returned by DrMXEnum_New().
*/
extern	VOID	WINAPI	DrMXEnum_Delete(RDrMXEnum aE);

/*
  aE  : enumerator reference returned by DrMXEnum_New().
  aID : variable which receives device id, null-terminated
        (must allocate at least 16 characters).
 returns TRUE if valid, otherwise FALSE.
*/
extern	BOOL	WINAPI	DrMXEnum_NextW(RDrMXEnum aE, WCHAR aID[16]);
extern	BOOL	WINAPI	DrMXEnum_NextA(RDrMXEnum aE, CHAR aID[16]);

#ifdef UNICODE
#define	DrMXEnum_Next	DrMXEnum_NextW
#else
#define	DrMXEnum_Next	DrMXEnum_NextA
#endif


/*--- device ---*/

/*
 NULL if failed
*/
extern	RDrMX	WINAPI	DrMX_Open();

/*
 NULL if failed
*/
extern	RDrMX	WINAPI	DrMX_OpenIDA(LPCSTR aID);
extern	RDrMX	WINAPI	DrMX_OpenIDW(LPCWSTR aID);

#ifdef UNICODE
#define	DrMX_OpenID	DrMX_OpenIDW
#else
#define	DrMX_OpenID	DrMX_OpenIDA
#endif

/*
 aR : device reference returned by DrMX_Openxx().
*/
extern	VOID	WINAPI	DrMX_Close(RDrMX aR);

/*
  aP : pointer to a byte array. 1st byte is a start code.
  aL : length (513 byte max)
  aT : timeout [mS]
 returns 1 if written, otherwise 0.
*/
extern	DWORD	WINAPI	DrMX_Write(RDrMX aR, const BYTE* aP, DWORD aL, DWORD aT);

/*
  aP : pointer to a byte array. 1st byte is a start code.
  aL : length (513 byte max)
  aT : timeout [mS]
 returns byte count.
*/
extern	DWORD	WINAPI	DrMX_Read(RDrMX aR, BYTE* aP, DWORD aL, DWORD aT);

/*
  aBrk : break space extension, in addition to minimum 92, default 84 (176uS) [0 255] [uS].
  aMAB : Mark After Break extension, in addition to minimum 12, default 0 [0 255] [uS].
  aMBS : Mark Between Slot, default 0 [0 255] [uS].
 returns TRUE if succeeded.
*/
extern	BOOL	WINAPI	DrMX_SetTiming(RDrMX aR, DWORD aBrk, DWORD aMAB, DWORD aMBS);


#ifdef __cplusplus
}
#endif

#endif
