// Win Main //

#include	<windows.h>
#include	"DDrMXLib.h"


#define	kTimerID		(1)
#define	kTimerTime		(40)
#define	kDmxOutTo		(10)
#define	kWindowClass	TEXT("DRMXLTEST")


HINSTANCE				gInstance(NULL);
RDrMX					gDrMX(NULL);
static unsigned	char	gData[513];


static	void	OpenDrMX(HWND aWin)
{
	gDrMX = DrMX_Open();
	if (gDrMX != NULL)
	{

		DrMX_SetTiming(gDrMX, 100, 100, 100);

		SetTimer(aWin, kTimerID, kTimerTime, NULL);
	}
	else
	{
		MessageBox(NULL, TEXT("No DrMX"), NULL, MB_OK);
	}
}


static	void	CloseDrMX(HWND aWin)
{
	if (gDrMX != NULL)
	{
		KillTimer(aWin, kTimerID);
		DrMX_Close(gDrMX);
		gDrMX = NULL;
	}
}


LRESULT	CALLBACK	WindowProc(HWND aWin, UINT aMsg, WPARAM aWP, LPARAM aLP)
{
	switch (aMsg)
	{
	case WM_CREATE:
		OpenDrMX(aWin);
		break;
	case WM_DESTROY:
		CloseDrMX(aWin);		
		PostQuitMessage(0);
		break;
	case WM_TIMER:
		if (gDrMX != NULL)
		{
			DWORD	r = DrMX_Write(gDrMX, gData, 513, kDmxOutTo);
		}
		return 0;
	case WM_PAINT:
		{
			PAINTSTRUCT	ps;
			HDC			dc = BeginPaint(aWin, &ps);

			FillRect(dc, &ps.rcPaint, (HBRUSH)(COLOR_WINDOW + 1));
			EndPaint(aWin, &ps);
		}
		return 0;
	case WM_LBUTTONDOWN:
		if (gDrMX == NULL)
		{
			OpenDrMX(aWin);
		}
		else
		{
			CloseDrMX(aWin);		
		}
		return 0;
	}
	return DefWindowProc(aWin, aMsg, aWP, aLP);
}


int	WINAPI	WinMain(HINSTANCE anIns, HINSTANCE aPrv, LPSTR anArg, int aMode)
{
	gInstance = anIns;

	{
		WNDCLASSEX	wc;

		memset(&wc, 0, sizeof(wc));
		wc.cbSize = sizeof(wc);
		wc.hInstance = gInstance;
		wc.lpfnWndProc = WindowProc;
		wc.lpszClassName = kWindowClass;
	//	wc.hIcon = ;
	//	wc.hIconSm = ;
		RegisterClassEx(&wc);
	}

	HWND	w = CreateWindow(kWindowClass, TEXT("DrMXLTest"), WS_OVERLAPPEDWINDOW | WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT, 200, 100, NULL, NULL, gInstance, NULL);

	{
		MSG		m;
	
		while (GetMessage(&m, NULL, 0, 0))
		{
			TranslateMessage(&m);
			DispatchMessage(&m);
		}
	}
	return 0;
}
