// DoctorMX Library Test //

#include	<windows.h>
#include	<stdio.h>
#include	"DDrMXLib.h"


typedef	unsigned char	uchar;
typedef	unsigned int	uint;
	

int		main()
{
	puts("DrMXLib Test");

	RDrMXEnum	drmxenum = DrMXEnum_New();
	
	if (drmxenum != NULL)
	{
		char	drmxid[16];

		while (DrMXEnum_Next(drmxenum, drmxid))
		{
			printf("Device ID: %s\n", drmxid);

			RDrMX	drmx = DrMX_OpenID(drmxid);

			if (drmx != NULL)
			{
				puts("DrMXLib is opened.");

				DWORD	r;
				uchar	wb[513];
				uchar	rb[513];
				
				memset(wb, 0, sizeof(wb));
				memset(rb, 1, sizeof(rb));

				for (uint i = 0; i < 513; ++i)
				{
					wb[i] = i;
				}
				r = DrMX_Write(drmx, wb, 513, 100);
				if (r)
				{
					puts("Written to DrMXLib.");
				}
				else
				{
					puts("Cannot write to DrMXLib.");
				}
				r = DrMX_Write(drmx, wb, 513, 100);	// closure
				
				Sleep(30);

				r = DrMX_Read(drmx, rb, 513, 100);
				if (r == sizeof(rb))
				{
					puts("Read from DrMXLib.");
					if (memcmp(wb, rb, 513) == 0)
					{
						puts("Write/Read match.");
					}
					else
					{
						puts("Write/Read unmatch.");
					}
				}
				else
				{
					puts("Cannot read from DrMXLib.");
				}

				DrMX_Close(drmx);
			}
			else
			{
				puts("DrMXLib is not opened.");
			}
		}

		DrMXEnum_Delete(drmxenum);
	}
	return 0;
}
